<template>
  <el-dialog
    :title="title"
    :visible.sync="dialogFormVisible"
    width="500px"
    @close="close"
  >
    <el-form ref="form" label-width="120px" :model="form" :rules="rules">
      <el-form-item :label="__('客户等级名称')" prop="customer_level_name">
        <el-input
          v-model="form.customer_level_name"
          :placeholder="__('客户等级名称')"
        />
      </el-form-item>
      <el-form-item :label="__('客户等级描述')" prop="customer_level_desc">
        <el-input
          v-model="form.customer_level_desc"
          :placeholder="__('客户等级描述')"
        />
      </el-form-item>
      <el-form-item
        :label="__('折扣百分比')"
        prop="customer_level_discountrate"
      >
        <el-input
          v-model="form.customer_level_discountrate"
          :placeholder="__('折扣百分比')"
        />
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="close">{{ __('取消') }}</el-button>
      <el-button type="primary" @click="save">{{ __('确定') }}</el-button>
    </div>
  </el-dialog>
</template>

<script>
  import { translateTitle as __ } from '@/utils/i18n'

  import { doEdit } from '@/api/customer/level'

  export default {
    name: 'CustomerLevelEdit',
    data() {
      return {
        form: {},
        rules: {},
        title: '',
        dialogFormVisible: false,
      }
    },
    created() {},
    mounted() {
      this.rules = {
        customer_level_id: [
          { required: true, trigger: 'blur', message: this.__('客户等级编号') },
        ],
        customer_level_name: [
          { required: true, trigger: 'blur', message: this.__('客户等级名称') },
        ],
        customer_level_desc: [
          { required: true, trigger: 'blur', message: this.__('客户等级描述') },
        ],
        customer_level_discountrate: [
          { required: true, trigger: 'blur', message: this.__('折扣百分比') },
        ],
        customer_level_is_buildin: [
          { required: true, trigger: 'blur', message: this.__('系统内置') },
        ],
        store_id: [
          { required: true, trigger: 'blur', message: this.__('所属店铺') },
        ],
        chain_id: [
          { required: true, trigger: 'blur', message: this.__('所属门店') },
        ],
      }

      this.$forceUpdate()
    },
    methods: {
      __,
      showEdit(row) {
        if (!row) {
          this.title = this.__('添加')
        } else {
          this.title = this.__('编辑')
          this.form = Object.assign({}, row)
        }
        this.dialogFormVisible = true
      },
      close() {
        this.form = this.$options.data().form
        this.$refs['form'].resetFields()
        this.dialogFormVisible = false
      },
      save() {
        this.$refs['form'].validate(async (valid) => {
          if (valid) {
            const { msg, status } = await doEdit(this.form)
            if (200 == status) {
              this.$baseMessage(msg, 'success')
            } else {
              this.$baseMessage(msg, 'error')
            }
            this.$emit('fetch-data')
            this.close()
          } else {
            return false
          }
        })
      },
    },
  }
</script>
